import gov.nasa.jpf.jvm.Verify; 

import java.util.List;  
import TestSpecifications.SpecificationManager; 

public  class  PL_Interface_impl  implements PL_Interface {
	
	public static void main(String[] args) {
		try {
			(new PL_Interface_impl()).start(-1,-1);
			System.out.println("no Exception");
		} catch (Throwable e) {
			System.out.println("Caught Exception: " + e.getClass() + " " + e.getMessage());
			e.printStackTrace();
		}
	}

	
	public void start(int specification, int variation) {
		runRandomActions(variation);
		//Scenario.test();
	}

	
	public void checkOnlySpecification(int specID) {
		SpecificationManager.checkOnlySpecification(specID);
	}

	
	public List<String> getExecutedActions() {
		return Test_Actions.actionHistory;
	}

	
	public boolean isAbortedRun() {
		return Scenario.abortedRun;
	}

	
	
	public void runRandomActions(int maxLength) {
		Test_Actions.setup();
		int counter = 0;
		while (counter < maxLength) {
			counter++;
			
			int action = Verify.getInt(0, 13); 
			
			switch (action) {
			case 0:	Test_Actions.bobKeyAdd(); break;
			case 1: Test_Actions.bobKeyAddChuck(); break;
			case 2: Test_Actions.bobKeyChange(); break;
			case 3: Test_Actions.bobSetAddressBook(); break;
			case 4: Test_Actions.chuckKeyAdd(); break;
			case 5: Test_Actions.rjhDeletePrivateKey(); break;
			case 6: Test_Actions.rjhEnableForwarding(); break;
			case 7: Test_Actions.rjhKeyAdd(); break;
			case 8: Test_Actions.rjhKeyAddChuck(); break;
			case 9: Test_Actions.rjhKeyChange(); break;
			case 10: Test_Actions.rjhSetAutoRespond(); break;
			
			case 11: Test_Actions.bobToAlias(); break;
			case 12: Test_Actions.bobToRjh(); break;
			case 13: Test_Actions.rjhToBob(); break;
			default:
				throw new InternalError("Missed a case!");
			}
			if (Test_Actions.executedUnimplementedAction) {
				//"invalid" path
				return;
			}
		}
	}


}
